/*
 * sd.h
 *
 *  Created on: 27 Aug 2011
 *      Author: Mike
 */

#ifndef SD_H_
#define SD_H_

#define COMMAND_0	(0x40 + 0)	// GO_IDLE_STATE
#define COMMAND_1	(0x40 + 1)	// SEND_OP_COND (MMC)
#define COMMAND_16 	(0x40 + 16)	// SET BLOCKLEN
#define COMMAND_17 	(0x40 + 17)	// READ_SINGLE_BLOCK
#define COMMAND_24 	(0x40 + 24)	// WRITE_BLOCK

#define MAX_TRIES 10
#define BUFFER_SIZE 512
#define BLOCK_SIZE_BITS 9

#include <wixel.h>
#include <spi.h>

// define SD_DEBUG to generate printf messages
//============================================
// #define SD_DEBUG

#ifdef SD_DEBUG
#include <stdio.h>
#define debug printf
#else
#define debug //
#endif


uint8 sdCommand(uint8 usartID, uint8 command, uint32 parameter, uint8 response, uint8 tries, uint8 timeout);
void sdIdle(void);
void sdInit(uint8 usartID);
uint8 sdReadBlock(uint8 usartID, uint32 LBA, uint8* buffer, uint16 size);
void sdReset(uint8 usartID, uint32 count);

#endif /* SD_H_ */
